Write-Host "Collecting data. Please wait..."

$dismOut = dism /online /get-drivers

$Lines = $dismOut | select -Skip 10


$Operation = "theName"

$Drivers = @()

foreach ( $Line in $Lines ) {

    $tmp = $Line

    $txt = $($tmp.Split( ':' ))[1]

    switch ($Operation) {

        'theName' { $Name = $txt

                     $Operation = 'theFileName'

                     break

                   }

        'theFileName' { $FileName = $txt.Trim()

                         $Operation = 'theEntr'

                         break

                       }

        'theEntr' { $Entr = $txt.Trim()

                     $Operation = 'theClassName'

                     break

                   }

        'theClassName' { $ClassName = $txt.Trim()

                          $Operation = 'theVendor'

                          break

                        }

        'theVendor' { $Vendor = $txt.Trim()

                       $Operation = 'theDate'

                       break

                     }

        'theDate' { # change the date format for easy sorting

                     $tmp = $txt.split( '.' )

                     $txt = "$($tmp[2]).$($tmp[1]).$($tmp[0].Trim())"

                     $Date = $txt

                     $Operation = 'theVersion'

                     break

                   }

        'theVersion' { $Version = $txt.Trim()

                        $Operation = 'theNull'

                        $params = [ordered]@{ 'FileName' = $FileName

                                              'Vendor' = $Vendor

                                              'Date' = $Date

                                              'Name' = $Name

                                              'ClassName' = $ClassName

                                              'Version' = $Version

                                              'Entr' = $Entr

                                            }

                        $obj = New-Object -TypeName PSObject -Property $params

                        $Drivers += $obj

                        break

                      }

         'theNull' { $Operation = 'theName'

                      break

                     }

    }

}
Write-Host " "
Write-Host " "
Write-Host "All installed third-party  drivers"
$ToDel = @()

$Hit1 ="MediaTek*"

$Drivers | sort Vendor | ft

 #Write-Host "found MediaTek"

 $last = ''

 $ToDelete = @()

 foreach ( $Dr in $($Drivers | sort Vendor) ) {

     if ($Dr.Vendor -like $Hit1  ) {  $ToDelete += $Dr  }

     $last = $Dr.FileName

 }

# Write-Host $ToDelete
$ToDel += $ToDelete

Write-Host ""
Write-Host ""




# Write-Host $ToDel



# removing unwanted drivers

 foreach ( $item in $ToDel ) {

    $Name = $($item.Name).Trim()

    Write-Host "deleting $Name" -ForegroundColor Yellow

    Write-Host "pnputil.exe -d $Name" -ForegroundColor Yellow

    invoke-Expression -Command "pnputil.exe -d $Name"

}